



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java springboot 大文件分片上传处理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java springboot 大文件分片上传处理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 22:22:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>参考自：<a href="https://blog.csdn.net/u014150463/article/details/74044467" rel="external nofollow noreferrer">https://blog.csdn.net/u014150463/article/details/74044467</a></p>
<p>这里只写后端的代码，基本的思想就是，前端将文件分片，然后每次访问上传接口的时候，向后端传入参数：当前为第几块文件，和分片总数</p>
<p>下面直接贴代码吧，一些难懂的我大部分都加上注释了：</p>
<p>上传文件实体类：</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * 文件传输对象<br />
 * @ApiModel和@ApiModelProperty及Controller中@Api开头的注解 是swagger中的注解 用于项目Api的自动生成，如果有没接触过的同学，可以把他理解为一个注释<br />
 */<br />
@ApiModel("大文件分片入参实体")<br />
public class MultipartFileParam {<br />
    @ApiModelProperty("文件传输任务ID")<br />
    private String taskId;<br />
    @ApiModelProperty("当前为第几分片")<br />
    private int chunk;<br />
    @ApiModelProperty("每个分块的大小")<br />
    private long size;

    @ApiModelProperty("分片总数")<br />
    private int chunkTotal;<br />
    @ApiModelProperty("主体类型--这个字段是我项目中的其他业务逻辑可以忽略")<br />
    private int objectType;<br />
    @ApiModelProperty("分块文件传输对象")<br />
    private MultipartFile file;</pre>
</div>
<p>首先是Controller层：</p>
<div>
<pre class="prettyprint linenums">     @ApiOperation("大文件分片上传")<br />
     @PostMapping("chunkUpload")<br />
     public void fileChunkUpload(MultipartFileParam param, HttpServletResponse response, HttpServletRequest request){<br />
         /**<br />
          * 判断前端Form表单格式是否支持文件上传<br />
          */<br />
         boolean isMultipart = ServletFileUpload.isMultipartContent(request);<br />
         if(!isMultipart){<br />
             //这里是我向前端发送数据的代码，可理解为 return 数据; 具体的就不贴了<br />
             resultData = ResultData.buildFailureResult("不支持的表单格式", ResultCodeEnum.NOTFILE.getCode());<br />
             printJSONObject(resultData,response);<br />
             return;<br />
         }<br />
         logger.info("上传文件 start...");<br />
         try {<br />
             String taskId = fileManage.chunkUploadByMappedByteBuffer(param);<br />
         } catch (IOException e) {<br />
             logger.error("文件上传失败。{}", param.toString());<br />
         }<br />
         logger.info("上传文件结束");<br />
     }</pre>
</div>
<p>　　Service层： FileManage 我这里是使用 ---直接字节缓冲器 MappedByteBuffer 来实现分块上传，还有另外一种方法使用RandomAccessFile 来实现的，使用前者速度较快所以这里就直说 MappedByteBuffer 的方法</p>
<p>　　具体步骤如下：</p>
<div>
<pre class="prettyprint linenums">第一步：获取RandomAccessFile,随机访问文件类的对象<br />
第二步：调用RandomAccessFile的getChannel()方法，打开文件通道 FileChannel<br />
第三步：获取当前是第几个分块，计算文件的最后偏移量<br />
第四步：获取当前文件分块的字节数组，用于获取文件字节长度<br />
第五步：使用文件通道FileChannel类的 map（）方法创建直接字节缓冲器  MappedByteBuffer<br />
第六步：将分块的字节数组放入到当前位置的缓冲区内  mappedByteBuffer.put(byte[] b);<br />
第七步：释放缓冲区<br />
第八步：检查文件是否全部完成上传</pre>
</div>
<p>　　如下代码：</p>
<div>
<pre class="prettyprint linenums">package com.zcz.service.impl;

import com.zcz.bean.dto.MultipartFileParam;<br />import com.zcz.exception.ServiceException;<br />import com.zcz.service.IFileManage;<br />import com.zcz.util.FileUtil;<br />import com.zcz.util.ImageUtil;<br />import org.apache.commons.io.FileUtils;<br />import org.springframework.beans.factory.annotation.Value;<br />import org.springframework.stereotype.Service;<br />import org.springframework.web.multipart.MultipartFile;<br />import java.io.*;<br />import java.nio.MappedByteBuffer;<br />import java.nio.channels.FileChannel;<br />import java.util.*;

/**<br /> * 文件上传服务层<br /> */<br />@Service("fileManage")<br />public class FileManageImpl implements IFileManage {

    @Value("${basePath}")<br />    private String basePath;

    @Value("${file-url}")<br />    private String fileUrl;

    /**<br />     * 分块上传<br />     * 第一步：获取RandomAccessFile,随机访问文件类的对象<br />     * 第二步：调用RandomAccessFile的getChannel()方法，打开文件通道 FileChannel<br />     * 第三步：获取当前是第几个分块，计算文件的最后偏移量<br />     * 第四步：获取当前文件分块的字节数组，用于获取文件字节长度<br />     * 第五步：使用文件通道FileChannel类的 map（）方法创建直接字节缓冲器  MappedByteBuffer<br />     * 第六步：将分块的字节数组放入到当前位置的缓冲区内  mappedByteBuffer.put(byte[] b);<br />     * 第七步：释放缓冲区<br />     * 第八步：检查文件是否全部完成上传<br />     * @param param<br />     * @return<br />     * @throws IOException<br />     */<br />    @Override<br />    public String chunkUploadByMappedByteBuffer(MultipartFileParam param) throws IOException {<br />        if(param.getTaskId() == null || "".equals(param.getTaskId())){<br />            param.setTaskId(UUID.randomUUID().toString());<br />        }<br />        /**<br />         * basePath是我的路径，可以替换为你的<br />         * 1：原文件名改为UUID<br />         * 2：创建临时文件，和源文件一个路径<br />         * 3：如果文件路径不存在重新创建<br />         */<br />        String fileName = param.getFile().getOriginalFilename();<br />　　　　 //fileName.substring(fileName.lastIndexOf(".")) 这个地方可以直接写死 写成你的上传路径<br />        String tempFileName = param.getTaskId() + fileName.substring(fileName.lastIndexOf(".")) + "_tmp";<br />        String filePath = basePath + getFilePathByType(param.getObjectType()) + "/original";<br />        File fileDir = new File(filePath);<br />        if(!fileDir.exists()){<br />            fileDir.mkdirs();<br />        }<br />        File tempFile = new File(filePath,tempFileName);<br />        //第一步<br />        RandomAccessFile raf = new RandomAccessFile(tempFile,"rw");<br />        //第二步<br />        FileChannel fileChannel = raf.getChannel();<br />        //第三步<br />        long offset = param.getChunk() * param.getSize();<br />        //第四步<br />        byte[] fileData = param.getFile().getBytes();<br />        //第五步<br />        MappedByteBuffer mappedByteBuffer = fileChannel.map(FileChannel.MapMode.READ_WRITE,offset,fileData.length);<br />        //第六步<br />        mappedByteBuffer.put(fileData);<br />        //第七步<br />        FileUtil.freeMappedByteBuffer(mappedByteBuffer);<br />        fileChannel.close();<br />        raf.close();<br />        //第八步<br />        boolean isComplete = checkUploadStatus(param,fileName,filePath);<br />        if(isComplete){<br />            renameFile(tempFile,fileName);<br />        }<br />        return "";<br />    }

    /**<br />     * 文件重命名<br />     * @param toBeRenamed   将要修改名字的文件<br />     * @param toFileNewName 新的名字<br />     * @return<br />     */<br />    public boolean renameFile(File toBeRenamed, String toFileNewName) {<br />        //检查要重命名的文件是否存在，是否是文件<br />        if (!toBeRenamed.exists() || toBeRenamed.isDirectory()) {<br />            return false;<br />        }<br />        String p = toBeRenamed.getParent();<br />        File newFile = new File(p + File.separatorChar + toFileNewName);<br />        //修改文件名<br />        return toBeRenamed.renameTo(newFile);<br />    }

    /**<br />     * 检查文件上传进度<br />     * @return<br />     */<br />    public boolean checkUploadStatus(MultipartFileParam param,String fileName,String filePath) throws IOException {<br />        File confFile = new File(filePath,fileName+".conf");<br />        RandomAccessFile confAccessFile = new RandomAccessFile(confFile,"rw");<br />        //设置文件长度<br />        confAccessFile.setLength(param.getChunkTotal());<br />        //设置起始偏移量<br />        confAccessFile.seek(param.getChunk());<br />        //将指定的一个字节写入文件中 127，<br />        confAccessFile.write(Byte.MAX_VALUE);<br />        byte[] completeStatusList = FileUtils.readFileToByteArray(confFile);<br />        byte isComplete = Byte.MAX_VALUE;<br />　　　　　//这一段逻辑有点复杂，看的时候思考了好久，创建conf文件文件长度为总分片数，每上传一个分块即向conf文件中写入一个127，那么没上传的位置就是默认的0,已上传的就是Byte.MAX_VALUE 127<br />        for(int i = 0; i&lt;completeStatusList.length &amp;&amp; isComplete==Byte.MAX_VALUE; i++){<br />　　　　　　　// 按位与运算，将&amp;两边的数转为二进制进行比较，有一个为0结果为0，全为1结果为1  eg.3&amp;5&nbsp; 即 0000 0011 &amp; 0000 0101 = 0000 0001&nbsp;&nbsp; 因此，3&amp;5的值得1。<br />            isComplete = (byte)(isComplete &amp; completeStatusList[i]);<br />            System.out.println("check part " + i + " complete?:" + completeStatusList[i]);<br />        }<br />        if(isComplete == Byte.MAX_VALUE){<br />　　　　　　  //如果全部文件上传完成，删除conf文件<br />　　　　　　  confFile.delete();<br />            return true;<br />        }<br />        return false;<br />    }<br />　　</pre>
<pre class="prettyprint linenums">    /**<br />　　 * 根据主体类型，获取每个主题所对应的文件夹路径 我项目内的需求可以忽略<br />　　 * @param objectType <br /> 　　* @return filePath 文件路径<br />　　 */<br />　　private String getFilePathByType(Integer objectType){<br />   　　 //不同主体对应的文件夹<br />　　    Map&lt;Integer,String&gt; typeMap = new HashMap&lt;&gt;();<br />   　　 typeMap.put(1,"Article");<br />　　    typeMap.put(2,"Question");<br />　　    typeMap.put(3,"Answer");<br />　　    typeMap.put(4,"Courseware");<br />　　    typeMap.put(5,"Lesson");<br />　　    String objectPath = typeMap.get(objectType);<br />　　    if(objectPath==null || "".equals(objectPath)){<br />　　        throw  new ServiceException("主体类型不存在");<br />　　    }<br />   　　 return objectPath;<br />　　}</pre>
<pre class="prettyprint linenums">}</pre>
</div>
<p>　　FileUtil：</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 在MappedByteBuffer释放后再对它进行读操作的话就会引发jvm crash，在并发情况下很容易发生<br />
     * 正在释放时另一个线程正开始读取，于是crash就发生了。所以为了系统稳定性释放前一般需要检 查是否还有线程在读或写<br />
     * @param mappedByteBuffer<br />
     */<br />
    public static void freedMappedByteBuffer(final MappedByteBuffer mappedByteBuffer) {<br />
        try {<br />
            if (mappedByteBuffer == null) {<br />
                return;<br />
            }<br />
            mappedByteBuffer.force();<br />
            AccessController.doPrivileged(new PrivilegedAction&lt;Object&gt;() {<br />
                @Override<br />
                public Object run() {<br />
                    try {<br />
                        Method getCleanerMethod = mappedByteBuffer.getClass().getMethod("cleaner", new Class[0]);<br />
                        //可以访问private的权限<br />
                        getCleanerMethod.setAccessible(true);<br />
                        //在具有指定参数的 方法对象上调用此 方法对象表示的底层方法<br />
                        sun.misc.Cleaner cleaner = (sun.misc.Cleaner) getCleanerMethod.invoke(mappedByteBuffer,<br />
                                new Object[0]);<br />
                        cleaner.clean();<br />
                    } catch (Exception e) {<br />
                        logger.error("clean MappedByteBuffer error!!!", e);<br />
                    }<br />
                    logger.info("clean MappedByteBuffer completed!!!");<br />
                    return null;<br />
                }<br />
            });<br />
        } catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
    }</pre>
</div>
<p>　　好了，到此就全部结束了，如果有疑问或批评，欢迎评论和私信，我们一起成长一起学习。</p>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1v21zq.html">Shell基础学习小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlrej9.html">php缓存技术（减少数据库服务器压力）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xpdz9.html">skip-grant-tables：非常有用的mysql启动参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xeg709.html">Unity 鼠标点击左右移动&comma;人物跟随旋转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okzop59.html">HTTP请求的TCP瓶颈分析&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z0n249.html">log4&period;net 日志工具使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmn71z9.html">使用Xib添加自定义View</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1ywygq.html">windows已安装solr</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjvyo28.html">使用SoapUI 测试Web Service</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zp7j59.html">【NOIP2013提高组】货车运输</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekzk78.html">shareInstance</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6o279.html">java中最常用jar包的用途说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkgn4j8.html">●BZOJ 1499 &lbrack;NOI2005&rsqb;瑰丽华尔兹</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7v7l8.html">从壹开始前后端分离 &lbrack; Vue2&period;0&plus;&period;NET Core2&period;1&rsqb; 十四 &boxV;  VUE 计划书 &amp;amp&semi; 我的前后端开发简史</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyzjrj9.html">leetcode python最长回文子串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv14y6xq.html">laravel之知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e41dmk9.html">Python读取文件内容与存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g00e0q.html">linux gcc 静态 动态链接库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmpok8.html">前端三大框架Angular &amp;amp&semi; React &amp;amp&semi; Vue</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvo609.html">Docker  入门指南&mdash;&mdash;Dockerfile 指令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1lp11q.html">P1462 通往奥格瑞玛的道路</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pe25j8.html">【CSA35G】【XSY3318】Counting Quests DP 拉格朗日反演 NTT</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdr5j49.html">git学习01- 下载安装&amp;amp&semi;初始化库&amp;amp&semi;提交</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgxrgm8.html">微信小程序之：wepy&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj43g69.html">Day050--jQuery表单事件 轮播图 插件库 ajax</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zowzgvq.html">经典面试题-python函数之默认参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zrr7g9.html">2017-12-20python全栈9期第五天第一节之昨日内容回顾和作业讲解之字母变大写</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pee7v8.html">洛伦兹曲线（Lorenz curve）提升指数、提升表和提升图</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k31j09.html">&lbrack;面试&rsqb;死锁-最简单的死锁demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gewogz8.html">Angular记录&lpar;3&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
